/*
** SDMMC.h SD card interface 
** 
** 07/20/07 v1.4 LDJ
** 11/22/07 v1.5 LDJ
**
*/
#define FALSE	0
#define TRUE	1
#define FAIL    FALSE

// insert LED definitions in your code if desired (otherwise Nop()
//#define READ_LED		_LATE0
#define READ_LED_ON		LATECLR = 1
#define READ_LED_OFF	LATESET = 1
#define WRITE_LED_ON	LATECLR = 1
#define WRITE_LED_OFF	LATESET = 1
#define INITSUCCESS_LED_ON	LATECLR = 8
#define INITSUCCESS_LED_OFF	LATESET = 8

// Init ERROR code definitions
#define E_COMMAND_ACK       0x80
#define E_INIT_TIMEOUT      0x81


typedef unsigned  LBA;  // logic block address, 32 bit wide

void initSD( void);     // initializes I/O pins and SPI
int initMedia( void);   // initializes the SD/MMC memory device

int getCD();            // check card presence
int getWP();            // check write protection tab

int readSECTOR ( LBA, unsigned char *);  // reads a block of data 
int writeSECTOR( LBA, unsigned char *);  // writes a block of data

