//ABC80 emulated memory handled by assembler isr
//All memory mapped implementations should define the use of ABC80 memory here!
//All ABCmemory initialisation is done in abcMem_init() in abcbus.c

extern const unsigned char abcRom[32768];	//declared in abcrom.S
extern volatile unsigned char __attribute__((persistent)) abcMem[65536];	//will copy from abcRom[]
extern unsigned char WEmap[256];	//Set WEmap[0]==0 to write protect abcMem[0..255]
//memory is initialized in abcbus.c

//------- memory mapped buffers --------------------
#define SDBUF		(16384+1024)	//256 byte buffer for SD card
#define Q0BUF		(SDBUF+256)
#define SEROUT_BUF	(SDBUF+512) 	//256 bytes buffer for serial (wifi)
#define SERIN_BUF 	(SDBUF+768)
#define COMIN_BUF  	(SDBUF+1024)	//256 bytes for second com port
#define COMOUT_BUF 	(SDBUF+1280)

//------- SD interface handled in rjdos.c ----------
#define SDFNAM		(SDBUF-12)
#define SDFNO		(SDBUF-13)
#define SDSTAT		(SDBUF-14)
#define SDCMD		(SDBUF-15)
#define BLK			(SDBUF-17)
#define BLKSZ		(SDBUF-18)

//------ UART interface handled in uarts.c ---------------------
#define SERIN_TAIL	(SDBUF-19) 		//circular in buffer read pointer
#define SERIN_HEAD	(SDBUF-20) 		//circuilar in buffer write pointer
#define SEROUT_TAIL	(SDBUF-21) 		//serial out byte read pointer
#define SEROUT_HEAD	(SDBUF-22) 		//serial out byte read pointer
#define SERERR		(SDBUF-23) 		//error byte

//------ memory handled by uarts.c ----------------------------
#define COMIN_TAIL	(SDBUF-25)
#define COMIN_HEAD	(SDBUF-26)
#define COMOUT_TAIL	(SDBUF-27)
#define COMOUT_HEAD	(SDBUF-28)
#define COMERR		(SDBUF-29)

//--------------------------------------------------------------

//end
