#define ABCBUS_VER	"0.6"
/*
ABCbus project
PORTD 15..0 = Address input
PORTA 7..0 = data input/output
INT1 (RE8) = MEMFL
INT2 (RE9) = MEMWR
*/

#include <p32xxxx.h>
#include <plib.h>
#include "my_typedefs.h"

#define setbit(var,bitno)  ((var) |= (1<<(bitno)))
#define clrbit(var,bitno)  ((var) &= ~(1<<(bitno)))

#define CR	0x0d
#define	LF	0x0a
#define ESC	0x1b

//#define LEDUSB_ON	LATECLR = 0
//#define LEDUSB_OFF	LATESET = 0
#define LEDGRN_ON	LATECLR = 8
#define LEDGRN_OFF	LATESET = 8
#define LEDWHT_ON	LATECLR = 4
#define LEDWHT_OFF	LATESET = 4
#define LEDRED_ON	LATECLR = 2
#define LEDRED_OFF	LATESET = 2
#define LEDYEL_ON	LATECLR = 1
#define LEDYEL_OFF	LATESET = 1
#define ABCRESIN	PORTEbits.RE5
#define SD_DETECT_PIN	PORTCbits.RC4

//TMR4 (32bit) can be used for timeouts, 0.8 s tick.
#define TMR4_ON		TMR4CONSET=0x8000
#define TMR4_OFF	TMR4CONCLR=0x8000
#define	TMR4_ms		(1250)

//------------------------------ functions -------------------------------------
void hw_init(void);				//in init.c
void usb_init(void);			//in usb.c
void usb(void);
void abcioInit(void);			//in abcio.c
void abcioCheck(void);
void abcio_disk_open(void);
void abcio_disk_close(void);
void delay_us(uint16 ticks);	//1 tick = 0.8 s.
int rjdos_sd_init(void);		//in rjdos.c
void rjdos_sd_close(void);
void rjdos(void);				//SD card SPI and debug stuff

void _general_exception_handler(unsigned cause, unsigned status);

//------------------------------ assembler isr ------------------------------------
extern void __attribute__((naked, at_vector(_EXTERNAL_1_VECTOR))) Int1Handler(void);	//assembler
extern void __attribute__((naked, at_vector(_EXTERNAL_2_VECTOR))) Int2Handler(void);	//assembler
extern void __attribute__((naked, at_vector(_TIMER_3_VECTOR))) TMR3Handler(void);		//assembler
//TMR3 interrupt must be invoked once to preload shadow registers used the other interrupts!

extern void __attribute__((naked, at_vector(_EXTERNAL_3_VECTOR))) Int3Handler(void);	//assembler
extern void __attribute__((naked, at_vector(_EXTERNAL_4_VECTOR))) Int4Handler(void);	//assembler
extern void __attribute__((naked, at_vector(_CHANGE_NOTICE_VECTOR))) CNHandler(void);	//assembler

//end
